<?php
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
//////■ 以下スクリプト ■////
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
mb_language("japanese");
mb_internal_encoding("UTF-8");
error_reporting("E_ALL & ~E_NOTICE | E_STRICT");

// 外部ファイル読み込み
require_once('./config.php');
require_once($GLOBALS['path']['php']['system']);

// 携帯判別
if (!preg_match("/(iPhone|iPod|iPad|Android|BlackBerry|Windows\ Phone)/i", $_SERVER['HTTP_USER_AGENT']) &&
	preg_match("/(DoCoMo|SoftBank|Vodafone|J-PHONE|KDDI-|UP\.Browser|DDIPOCKET|WILLCOM)/i", $_SERVER['HTTP_USER_AGENT'])) {
	@header("HTTP/1.1 301 Moved Permanently");
	@header("Status: 301 Moved Permanently");
	@header("Location: ". $GLOBALS['path']['php']['mobile']);
	exit;
}

$GLOBALS['script'] = $GLOBALS['path']['php']['main'];

configread(); // 設定データ取得
requestdecode(); // リクエストデコード
noveldata(1); // 小説データ取得

// 処理分岐
if ($_GET['mode'] === 'novel') {
	novel();
} else if ($_GET['mode'] === 'text') {
	text();
}

else if ($_POST['mode'] === 'clap') {
	clap();
} else if ($_POST['mode'] === 'clapmessage') {
	clapmessage();
} else if ($_POST['mode'] === 'bookmark') {
	bookmark();
} else if ($_POST['mode'] === 'namechenge') {
	namechenge();
} else {
	top();
}

exit;
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ヘッダ・フッタ
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function htmlheader() {
	htmlstart();

	echo '
	<div data-role="header" data-theme="'. $GLOBALS['CSTM']['mt_main']. '">
	';
		if (isset($GLOBALS['NOVEL'][$_GET['nvno']]['title'])) {
			echo '
			<h3>&nbsp;</h3>
			<div data-role="controlgroup" data-type="horizontal" class="ui-btn-left">
				<a href="'. $GLOBALS['script']. '?" data-role="button">ＴＯＰ</a>
				<a href="'. $GLOBALS['script']. '?mode=novel&nvno='. $_GET['nvno']. '" data-role="button" class="novel-title">'. $GLOBALS['NOVEL'][$_GET['nvno']]['title']. '</a>
			</div>
			';
		} else {
			echo '
			<h1 style="text-align: left; margin-left: 10px;">'. $GLOBALS['CSTM']['maintitle']. '</h1>
			';
		}

		if (!empty($GLOBALS['CSTM']['homeurl'])) {
			echo '
			<a href="'. $GLOBALS['CSTM']['homeurl']. '" data-role="button" data-icon="home" data-iconpos="notext" rel="external" class="ui-btn-right">HOME</a>
			';
		}

		echo '
	</div>
	<div id="pagewrap">
	';
}
function htmlfooter() {
	echo '
	</div>
	<div data-role="footer" data-theme="'. $GLOBALS['CSTM']['mt_main']. '">
		<h3>&nbsp;</h3>
		';

		if (isset($GLOBALS['NOVEL'][$_GET['nvno']]['title'])) {
			echo '
			<div data-role="controlgroup" data-type="horizontal" class="ui-btn-left">
				<a href="'. $GLOBALS['script']. '?" data-role="button">ＴＯＰ</a>
				<a href="'. $GLOBALS['script']. '?mode=novel&nvno='. $_GET['nvno']. '" data-role="button" class="novel-title">'. $GLOBALS['NOVEL'][$_GET['nvno']]['title']. '</a>
			</div>
			';
		} else {
			echo '
			<a href="'. $GLOBALS['path']['php']['admin']. '?" data-role="button" data-icon="gear" data-iconpos="notext" class="ui-btn-left">admin</a>
			';
		}

		htmlend();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ トップページ
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function top() {
	htmlheader();

	echo '
	<div id="contents-main">
		<div data-role="content">
			<p>'. $GLOBALS['CSTM']['topmsg']. '</p>
			';

			// 小説一覧
			$page = 0;
			$maxpage = count($GLOBALS['NOVEL']);
			$nowpage = (!empty($_GET['page'])) ? $_GET['page'] : 1;
			foreach ($GLOBALS['NOVEL'] as $nvno => $NOVEL) {
				$page++;

				if ($nowpage > 1 && $page <= (($nowpage-1) * $GLOBALS['CSTM']['novelpgmx'])) continue;

				//<a href="'. $GLOBALS['script']. '?mode=text&nvno='. $nvno. '&page=1" data-role="button" data-icon="columns">最初から読む</a>
				echo '
				<div class="ui-body ui-body-'. $GLOBALS['CSTM']['mt_sub']. ' ui-corner-all ui-shadow" style="margin-bottom: 15px;">
					<h4 class="title-shadow" style="margin: 10px 0;">'. $NOVEL['title']. '</h4>
					<hr />
					<p>'. $NOVEL['message']. '</p>
					<p class="date">'. date("Y/m/d H:i", (($NOVEL['status'] === 'reserve') ? $NOVEL['rsvtime'] : $NOVEL['time_l'])). '更新</p>
					<div data-role="controlgroup" data-type="horizontal" data-mini="true" style="float: left; margin-right: 5px;">
						<a href="'. $GLOBALS['script']. '?mode=novel&nvno='. $nvno. '" data-role="button" data-icon="book">この小説を読む</a>
					</div>
					'. ((!empty($_COOKIE['bookmark-novel'.$NOVEL['fmtno']])) ? '
						<div data-role="controlgroup" data-type="horizontal" data-mini="true" style="float: left;">
							<a href="'. $GLOBALS['script']. '?mode=text&nvno='. $nvno. '&page='. $_COOKIE['bookmark-novel'.$NOVEL['fmtno']]. '"
							 data-role="button" data-theme="e" data-icon="bookmark">続きから読む</a> 
						</div>
					' : ''). '
					<div style="clear: both;"></div>
				</div>
				';

				//$novellist .= '
				//<li><a href="'. $GLOBALS['script']. '?mode=text&nvno='. $nvno. '"
				//>'. $GLOBALS['NOVEL'][$nvno]['title']. '</a></li>
				//';

				if ($page >= ($nowpage * $GLOBALS['CSTM']['novelpgmx'])) break;
			}

			if ($maxpage > $GLOBALS['CSTM']['novelpgmx']) {
				echo '
				<div data-role="controlgroup" data-type="horizontal" data-mini="true">
				';

				if ($nowpage != 1) {
					$back = $nowpage - 1;
					echo '<a href="'.$GLOBALS['script'].'?page='.$back.'" data-role="button" data-icon="arrow-l">前へ</a>';
				} else {
					echo '<a href="#" data-role="button" data-icon="arrow-l" class="disableButton">前へ</a>';
				}

				if (($nowpage * $GLOBALS['CSTM']['novelpgmx']) < $maxpage) {
					$next = $nowpage + 1;
					echo '<a href="'.$GLOBALS['script'].'?page='.$next.'" data-role="button" data-icon="arrow-r">次へ</a>';
				} else {
					echo '<a href="#" data-role="button" data-icon="arrow-r" class="disableButton">次へ</a>';
				}

				echo '
				</div>
				';
			}

			echo '
		</div>
	</div>
	<div id="contents-side">
		';

		// Twitter
		// 2013/12/10 TwitterAPI仕様変更により廃止
		// if ($GLOBALS['CSTM']['twitter'] == 1) {
		// 	echo '
		// 	<ul id="timeline" data-role="listview" data-divider-theme="'. $GLOBALS['CSTM']['mt_sub']. '" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '">
		// 		';

		// 		$divider = '<li data-role="list-divider"><span class="ui-icon-twitter">&nbsp;</span> ';
		// 		$REQ = array();
		// 		if (!empty($GLOBALS['CSTM']['twt_id'])) { $divider .= '@'.$GLOBALS['CSTM']['twt_id'].' '; $REQ[] = 'from:'.$GLOBALS['CSTM']['twt_id']; }
		// 		if (!empty($GLOBALS['CSTM']['twt_tag'])) { $divider .= '#'.$GLOBALS['CSTM']['twt_tag'].' '; $REQ[] = '#'.$GLOBALS['CSTM']['twt_tag']; }
		// 		$divider .= 'TL</li>';

		// 		echo '
		// 		<input type="hidden" id="q" value="'. implode("+", $REQ). '" />
		// 		<input type="hidden" id="rpp" value="'. $GLOBALS['CSTM']['twt_tl']. '" />
		// 		'. $divider. '
		// 	</ul>
		// 	<div data-role="content">
		// 		<a href="#" data-role="button" data-mini="true" data-icon="double-angle-down" id="moretweet">もっと見る</a>
		// 	</div>
		// 	';
		// }

		echo '
	</div>
	<div style="clear: both;"></div>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 目次
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function mokuji() {
	echo '
	<div data-role="header" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '" style="margin-bottom: -1px;">
		<h3>目次</h3>
	</div>

	<ul data-role="listview" id="cplist" data-split-icon="arrow-d" data-split-theme="'. $GLOBALS['CSTM']['mt_sub']. '" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '">
		';
		foreach ($GLOBALS['PAGE'] as $page => $PAGE) {

			if ($PAGE['type'] === 'text' && empty($PAGE['cpno'])) {
				echo '
				<li>
					<a href="'. $GLOBALS['script']. '?mode=text&nvno='. $_GET['nvno']. '&page='. $page. '">
						<span'. (($_GET['page'] == $page) ? ' style="text-decoration: underline;"' : ''). '>'. $PAGE['title']. '</span>
					</a>
				</li>
				';
			} else if ($PAGE['type'] === 'chapter') {
				echo '
				<li style="margin-bottom:-1px; border-bottom: 1px solid #CCCCCC;">
					<a style="margin-left: 40px; margin-right: 0px;" href="'. $GLOBALS['script']. '?mode=text&nvno='. $_GET['nvno']. '&page='. $page. '">
						<span'. (($_GET['page'] == $page) ? ' style="text-decoration: underline;"' : ''). '>'. $PAGE['title']. '</span>
					</a>
					<a style="left: 1px; border-left-width: 0; border-right-width: 1px;" href="#" class="cpslide" id="cp'. $PAGE['fmtno']. '">chapter open</a>
				</li>
				';

				$endpage = end(array_keys($GLOBALS['TEXT'][$PAGE['fmtno']]));
				foreach ($GLOBALS['TEXT'][$PAGE['fmtno']] as $txpage => $TEXT) {

					//$title = sprintf("%02d", $page);
					//if (!empty($GLOBALS['PAGE'][$page]['title'])) $title .= ' '.$GLOBALS['PAGE'][$page]['title'];

					$lineimg = $GLOBALS['path']['dir']['img'].
					(($txpage == $endpage) ? $GLOBALS['path']['img']['line-r'] : $GLOBALS['path']['img']['line-rd']);

					echo '
					<li class="nest_cp'. $TEXT['cpno']. '"'. (($_GET['page'] == $page || $PAGE['fmtno'] == $GLOBALS['PAGE'][$_GET['page']]['cpno']) ? '' : ' style="display: none;"'). '>
						<a href="'. $GLOBALS['script']. '?mode=text&nvno='. $_GET['nvno']. '&page='. $txpage. '">
							<img src="'. $lineimg. '" class="ui-li-icon list-line-img" />
							<span'. (($_GET['page'] == $txpage) ? ' style="text-decoration: underline;"' : ''). '>'. $TEXT['title']. '</span>
						</a>
					</li>
					';
				}
			}
		}
		echo '
	</ul>
	';
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 小説
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function novel() {
	htmlheader();

	echo '
	<div id="contents-main">
		<div data-role="content">
			<div class="ui-body ui-body-'. $GLOBALS['CSTM']['mt_sub']. ' ui-corner-all ui-shadow">
			<h2 class="title-shadow" style="text-align: center; margin: 25px auto 30px;">'. $GLOBALS['NOVEL'][$_GET['nvno']]['title']. '</h2>
				<hr />
				<p>'. $GLOBALS['NOVEL'][$_GET['nvno']]['outline']. '</p>
				<p class="date">'. date("Y/m/d H:i", $GLOBALS['NOVEL'][$_GET['nvno']]['time_l']). '更新</p>
			</div>
		</div>
	</div>
	<div id="contents-side">
	';

	mokuji();

	echo '
	</div>
	<div style="clear: both;"></div>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ページ表示
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function text() {
	// twitter
	$tweet = $GLOBALS['NOVEL'][$_GET['nvno']]['title'];

	// 名前変換
	$NAMECHENGE = array();
	$NMCNG_LIST = explode("<br />", $GLOBALS['NOVEL'][$_GET['nvno']]['namechenge']);
	$NMCNG_COOKIE = explode("&lt;&gt;", mb_convert_encoding($_COOKIE['namechenge-novel'.$GLOBALS['NOVEL'][$_GET['nvno']]['fmtno']], "utf-8", "auto"));
	foreach ($NMCNG_COOKIE as $usnmcng) {
		list($NAMECHENGE['search'][], $NAMECHENGE['replace'][]) = explode("=", $usnmcng, 2);
	}

	// 本文
	if ($GLOBALS['PAGE'][$_GET['page']]['type'] === 'text') {
		// ページ数
		if ($GLOBALS['CSTM']['cpview'] == 1) {
			$expage = '<p style="text-align: right;">page: '. $_GET['page']. ' / '. count($GLOBALS['PAGE']). '</p>';
		} else {
			$expage = '<p style="text-align: right;">page: '. $GLOBALS['PAGELCN'][$_GET['page']]. ' / '. count($GLOBALS['TYPE']['text']). '</p>';
		}

		list($maintext) = fileread('novel/'.$GLOBALS['NOVEL'][$_GET['nvno']]['fmtno'].'/txt'.$GLOBALS['PAGE'][$_GET['page']]['fmtno'].'.dat');

		// 名前変換実行
		if ($GLOBALS['CSTM']['namechenge'] == 1 && !empty($NMCNG_LIST[0])) {
			$maintext = str_replace($NAMECHENGE['search'], $NAMECHENGE['replace'], $maintext);
		}

		$cppgno = $GLOBALS['TYPE']['chapter'][$GLOBALS['PAGE'][$_GET['page']]['cpno']]; // 章番号取得

		$subtitle = ((isset($cppgno)) ? $GLOBALS['PAGE'][$cppgno]['title'].' － ' : '').
					$GLOBALS['PAGE'][$_GET['page']]['title']; // サブタイトル

		$tweet .= ' － '.$subtitle;

		$mainarea = '
		<h4 style="margin: 0px; padding: 0px;">'. $subtitle. '</h4>
		<div class="ui-grid-a">
			<div class="ui-block-a">
				<p class="date">'. date("Y/m/d H:i", $GLOBALS['PAGE'][$_GET['page']]['time_l']). '</p>
			</div>
			<div class="ui-block-b">'. $expage. '</div>
		</div>
		<div class="ui-body ui-body-'. $GLOBALS['CSTM']['texttheme']. '" style="padding: 4% 7%; margin: 0 -17px;">
			<p style="color: inherit;">'. $maintext. '</p>
		</div>
		';

	// 章
	} else if ($GLOBALS['PAGE'][$_GET['page']]['type'] === 'chapter') {
		// ページ数
		if ($GLOBALS['CSTM']['cpview'] == 1) {
			$expage = '<p style="text-align: right;">page: '. $_GET['page']. ' / '. count($GLOBALS['PAGE']). '</p>';
		}

		list($maintext) = fileread('novel/'.$GLOBALS['NOVEL'][$_GET['nvno']]['fmtno'].'/cp'.$GLOBALS['PAGE'][$_GET['page']]['fmtno'].'.dat');

		// 名前変換実行
		if ($GLOBALS['CSTM']['namechenge'] == 1 && !empty($NMCNG_LIST[0])) {
			$maintext = str_replace($NAMECHENGE['search'], $NAMECHENGE['replace'], $maintext);
		}

		$tweet .= ' － '.$GLOBALS['PAGE'][$_GET['page']]['title'];

		$mainarea = '
		<h4 style="margin: 10px 0;">'. $GLOBALS['PAGE'][$_GET['page']]['title']. '</h4>
		<p class="date">'. date("Y/m/d H:i", $GLOBALS['PAGE'][$_GET['page']]['time_l']). '</p>
		<hr />
		<p>'. $maintext. '</p>
		';
	}

	// ヘッダー／フッター
	$navi = '
	<h1>&nbsp;</h1>
	<div class="popupmenubtn">
		<a href="#popupmenu" data-rel="popup" data-role="button" data-icon="reorder" class="ui-btn-left">Menu</a>
	</div>
	<div data-role="controlgroup" data-type="horizontal" class="ui-btn-left menubuttons">
		<a href="#" data-role="button" data-icon="bookmark" class="bookmark">栞を挟む</a>
		';
		if ($GLOBALS['CSTM']['namechenge'] == 1 && !empty($NMCNG_LIST[0])) $navi .= '<a href="#namechenge" data-rel="popup" data-role="button" data-icon="retweet">名前変換</a>';
		if ($GLOBALS['CSTM']['twitter'] == 1) $navi .= '<a href="http://twitter.com/?status='. urlencode($tweet.' '.__FILE__.'?mode=text&page='.$_GET['page']). '" data-role="button" data-icon="twitter">ツイート</a>';
		$navi .= '
	</div>
	<div data-role="controlgroup" data-type="horizontal" class="ui-btn-right">
		';
		if ($_GET['page'] > 1) {
			$back = ($GLOBALS['CSTM']['cpview'] != 1 && $GLOBALS['PAGE'][($_GET['page'] - 1)]['type'] === 'chapter') ? $_GET['page'] - 2 : $_GET['page'] - 1;
			$navi .= '
			<a href="'. $GLOBALS['script']. '?mode=text&nvno='. $_GET['nvno']. '&page='. $back. '"
			 data-role="button" data-icon="arrow-l">Back</a>
			';
		} else {
			$navi .= '
			<a href="#" data-role="button" data-icon="arrow-l" class="disableButton">Back</a>
			';
		}
		if ($_GET['page'] < count($GLOBALS['PAGE'])) {
			$next = ($GLOBALS['CSTM']['cpview'] != 1 && $GLOBALS['PAGE'][($_GET['page'] + 1)]['type'] === 'chapter') ? $_GET['page'] + 2 : $_GET['page'] + 1;
			$navi .= '
			<a href="'. $GLOBALS['script']. '?mode=text&nvno='. $_GET['nvno']. '&page='. $next. '"
			 data-role="button" data-icon="arrow-r">Next</a>
			';
		} else {
			$navi .= '
			<a href="#" data-role="button" data-icon="arrow-r" class="disableButton">Next</a>
			';
		}
		$navi .= '
	</div>
	';

	// WEB拍手
	if ($GLOBALS['CSTM']['webclap'] == 1) {
		if ($GLOBALS['CSTM']['clapcount'] == 1) {
			$count = 0;
			foreach (fileread('clap/clap.dat') as $list) {
				list($nvno, $type, $pgfmtno, $clap) = explode("\t", rtrim($list));

				if ($nvno == $GLOBALS['NOVEL'][$_GET['nvno']]['fmtno']
				&& $type === $GLOBALS['PAGE'][$_GET['page']]['type']
				&& $pgfmtno == $GLOBALS['PAGE'][$_GET['page']]['fmtno']) {
					$count = $clap;
				}
			}
			$clapcount = ' <span style="color: #CC3333;" id="clapcount">'. $count. '</span>';
		}

		$clapbutton = '
		<button data-theme="'. $GLOBALS['CSTM']['mt_sub']. '" id="claping" data-mini="true" data-inline="true" data-transition="pop ">WEB拍手'. $clapcount. '</button>
		<div data-role="popup" id="sendclap" style="display: none;"></div>
		';
	}

	// 出力開始
	htmlheader();

	// ポップアップ-メニュー
	echo '
	<div data-role="popup" id="popupmenu">
		<a href="#" data-rel="back" data-role="button" data-theme="a" data-icon="delete" data-iconpos="notext" class="ui-btn-right">Close</a>
		<div data-role="controlgroup" style="margin: 0; min-width: 150px;">
			<a href="#" data-role="button" data-icon="bookmark" class="bookmark" style="text-align: left;">栞を挟む</a>
			';
			if ($GLOBALS['CSTM']['namechenge'] == 1 && !empty($NMCNG_LIST[0])) echo '<a href="#" id="nmcng_menupopup" data-role="button" data-icon="retweet" style="text-align: left;">名前変換</a>';
			if ($GLOBALS['CSTM']['twitter'] == 1) echo '<a href="http://twitter.com/?status='. urlencode($tweet.' '.__FILE__.'?mode=text&page='.$_GET['page']). '" data-role="button" data-icon="twitter" style="text-align: left;">ツイート</a>';
			echo '
		</div>
	</div>
	';

	// ポップアップ-名前変換
	if ($GLOBALS['CSTM']['namechenge'] == 1 && !empty($NMCNG_LIST[0])) {
		echo '
		<div data-role="popup" id="namechenge">
			<a href="#" data-rel="back" data-role="button" data-theme="a" data-icon="delete" data-iconpos="notext" class="ui-btn-right">Close</a>
			<form id="nmcng_form">
			<ul data-role="listview" data-inset="true" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '" data-divider-theme="'. $GLOBALS['CSTM']['mt_main']. '" style="min-width: 210px;">
				<li data-role="list-divider">名前変換</li>
				';
				$i = 0;
				foreach ($NMCNG_LIST as $nmcng) {
					list($name, $guide) = explode("=", $nmcng, 2);

					echo '
					<li data-role="fieldcontain">
						<input type="text" value="'. $NAMECHENGE['replace'][$i++]. '" placeholder="'. $name. '" />
						<p class="forminfo" style="margin-left: 0%;">'. $guide. '</p>
					</li>
					';
				}
				echo '
				<li class="ui-body ui-body-b">
					<button type="button" id="nmcng_submit" data-theme="a">設定保存</button>
				</li>
			</ul>
			</form>
		</div>
		';
	}

	// メインコンテンツ
	echo '
	<input type="hidden" name="nvno" value="'. $_GET['nvno']. '" />
	<input type="hidden" name="page" value="'. $_GET['page']. '" />
	<div id="contents-main">
		<a name="up" id="up"></a>
		<div data-role="header" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '">
			'. $navi. '
		</div>
		<div data-role="content">
			'. $mainarea. '
			<div class="ui-grid-a" style="margin-top: 10px;">
				<div class="ui-block-a">'. $clapbutton. '</div>
				<div class="ui-block-b">'. $expage. '</div>
			</div>
		</div>
		<a href="down" id="down"></a>
		<div data-role="footer" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '">
			'. $navi. '
		</div>
	</div>
	<div id="contents-side">
	';

	mokuji();

	echo '
	</div>
	<div style="clear: both;"></div>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ブックマーク
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function bookmark() {
	setcookie('bookmark-novel'.$GLOBALS['NOVEL'][$_POST['nvno']]['fmtno'], $_POST['page'], $GLOBALS['nowtime'] + 60 * 60 * 24 * 30, '/', false);

	@header('Content-Type: text/html; charset: utf-8');

	echo unicode_decode('現在のページに栞を挟みました。');
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 名前変換
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function namechenge() {
	setcookie('namechenge-novel'.$GLOBALS['NOVEL'][$_POST['nvno']]['fmtno'], $_POST['nmcngs'], $GLOBALS['nowtime'] + 60 * 60 * 24 * 30, '/', false);

	@header('Content-Type: text/html; charset: utf-8');

	echo unicode_decode('設定を保存しました。');
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ WEB拍手
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function clap() {
	$point = $GLOBALS['NOVEL'][$_POST['nvno']]['title'];

	if (!empty($_POST['page'])) {
		$point .= ' > '. ((!empty($GLOBALS['PAGE'][$_POST['page']]['title'])) ? $GLOBALS['PAGE'][$_POST['page']]['title'] : sprintf("%02d", $_POST['page']));
		$type = $GLOBALS['PAGE'][$_POST['page']]['type'];
		$pgfmtno = $GLOBALS['PAGE'][$_POST['page']]['fmtno'];
	} else {
		$type = 'novel';
	}

	$nvno = $GLOBALS['NOVEL'][$_POST['nvno']]['fmtno'];

	$newtime = $GLOBALS['nowtime'];
	$ushost = get_host();

	$WDATA = array();
	$JSON = array();

	// ▼当日拍手保存ファイル書き込み
	$clapdir = 'clap/'.date("Y");

	if (!file_exists($GLOBALS['path']['dir']['data'].$clapdir)) {
		umask(0);
		mkdir($GLOBALS['path']['dir']['data'].$clapdir);
	}

	$dayfile = "$clapdir/".date("m-d").'.dat';

	if (!file_exists($GLOBALS['path']['dir']['data'].$dayfile)) {
		// 新規ファイルから書き込み
		//$chainset = (isset($ckchain)) ? $ckchain : 1;
		$clapbase = "$newtime\t$nvno\t$type\t$pgfmtno\t$point\t$ushost\t1\t\t\t\n";
		array_push($WDATA, array($dayfile, $clapbase));
	} else {
		// 既存ファイルから書き込み
		$DAYLIST = fileread($dayfile);

		foreach ($DAYLIST as &$line) {
			list($time, $exnvno, $extype, $expgfmtno, $expoint, $host, $clap, $name, $tkb, $message) = explode("\t", $line);

			if ($exnvno == $nvno && $extype === $type && $expgfmtno == $pgfmtno && $host === $ushost) {

				//$chainset = (isset($ckchain)) ? $ckchain : $chain + 1;
				$clap += 1;

				// ホストチェックによる連続拍手制限
				if ($GLOBALS['CSTM']['clapmax'] > 0 && $clap > $GLOBALS['CSTM']['clapmax']) {
					@header('Content-Type: application/json; charset: utf-8');
					echo json_encode(array('_CLAPPING_OVER_'));
					return;
				}

				$line = "$time\t$exnvno\t$extype\t$expgfmtno\t$point\t$ushost\t$clap\t$name\t$tkb\t$message";
				$flga = 1;
				break;
			}
		}
		if (empty($flga)) {
			//$chainset = (isset($ckchain)) ? $ckchain : 1;
			array_push($DAYLIST, "$newtime\t$nvno\t$type\t$pgfmtno\t$point\t$ushost\t1\t\t\t\n");
		}

		array_push($WDATA, array($dayfile, $DAYLIST));
	}

	// ▼個別拍手保存ファイル書き込み
	$CLAPLIST = fileread('clap/clap.dat');
	foreach ($CLAPLIST as &$line) {
		list($exnvno, $extype, $expgfmtno, $clap) = explode("\t", rtrim($line));

		if ($exnvno == $nvno && $extype === $type && $expgfmtno == $pgfmtno) {
			$clap++;
			$line = "$nvno\t$extype\t$expgfmtno\t$clap\n";
			$flgb = 1;
			$clapcount = $clap;
			break;
		}
	}
	if (empty($flgb)) {
		array_push($CLAPLIST, "$nvno\t$type\t$pgfmtno\t1\n");
		$clapcount = 1;
	}
	array_push($WDATA, array('clap/clap.dat', $CLAPLIST));

	// ★データ書き込み
	filewrite($WDATA);

	if ($GLOBALS['CSTM']['clapcount'] == 1) $JSON[1] = $clapcount;

	$JSON[0] = '
	<a href="#" data-rel="back" data-role="button" data-theme="a" data-icon="delete" data-iconpos="notext" class="ui-btn-right">Close</a>
	<div class="ui-body">
		<h4>拍手ありがとうございます！</h4>
		<p>よろしければメッセージをどうぞ！</p>
		<form>
			<div data-role="fieldcontain" class="ui-hide-label">
				<label for="text">名前:</label>
				<input type="text" name="name" id="text" value="" data-mini="true" placeholder="名前" />
			</div>
			';

			if (!empty($GLOBALS['CSTM']['claptkb'])) {
				$JSON[0] .= '
				<div data-role="fieldcontain" class="ui-hide-label">
					<label for="select" class="select">定形文:</label>
					<select name="tkb" id="select" data-mini="true">
					<option value="">▼定形文</option>
					';
					foreach (explode("<br />", $GLOBALS['CSTM']['claptkb']) as $tkb) {
						$JSON[0] .= '<option value="'. $tkb. '">'. $tkb. '</option>';
					}
					$JSON[0] .= '
					</select>
				</div>
				';
			}

			$JSON[0] .= '
			<div data-role="fieldcontain" class="ui-hide-label">
				<label for="textarea">メッセージ:</label>
				<textarea name="message" id="textarea" data-mini="true" placeholder="メッセージ"></textarea>
			</div>
			<div data-role="fieldcontain">
				<input type="button" value="送信" id="msgsend" data-mini="true" />
			</div>
		</form>
	</div>
	';

	@header('Content-Type: application/json; charset: utf-8');

	echo json_encode($JSON);
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 拍手メッセージ
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function clapmessage() {
	$point = $GLOBALS['NOVEL'][$_POST['nvno']]['title'];

	if (!empty($_POST['page'])) {
		$point .= ' > '. ((!empty($GLOBALS['PAGE'][$_POST['page']]['title'])) ? $GLOBALS['PAGE'][$_POST['page']]['title'] : sprintf("%02d", $_POST['page']));
		$type = $GLOBALS['PAGE'][$_POST['page']]['type'];
		$pgfmtno = $GLOBALS['PAGE'][$_POST['page']]['fmtno'];
	} else {
		$type = 'novel';
	}

	$nvno = $GLOBALS['NOVEL'][$_POST['nvno']]['fmtno'];

	$newtime = $GLOBALS['nowtime'];
	$ushost = get_host();

	$WDATA = array();

	// ▼当日拍手保存ファイル書き込み
	$clapdir = 'clap/'.date("Y");

	if (!file_exists($GLOBALS['path']['dir']['data'].$clapdir)) {
		umask(0);
		mkdir($GLOBALS['path']['dir']['data'].$clapdir);
	}

	$dayfile = "$clapdir/".date("m-d").'.dat';

	if (!file_exists($GLOBALS['path']['dir']['data'].$dayfile)) {
		// 新規ファイルから書き込み
		$clapbase = "$newtime\t$nvno\t$type\t$pgfmtno\t$point\t$ushost\t1\t$_POST[name]\t$_POST[tkb]\t$_POST[message]\n";
		array_push($WDATA, array($dayfile, $clapbase));
	} else {
		// 既存ファイルから書き込み
		$DAYLIST = fileread($dayfile);

		foreach ($DAYLIST as &$line) {
			list($time, $exnvno, $extype, $expgfmtno, $expoint, $host, $clap, $name, $tkb, $message) = explode("\t", rtrim($line));

			if ($exnvno == $nvno && $extype === $type && $expgfmtno == $pgfmtno && $host === $ushost) {
				if (!empty($message)) $message .= "<br />";
				$message .= "$_POST[message]";
				$line = "$newtime\t$exnvno\t$extype\t$expgfmtno\t$point\t$ushost\t$clap\t$_POST[name]\t$_POST[tkb]\t$message\n";
				$flga = 1;
				break;
			}
		}
		if (empty($flga)) {
			array_push($DAYLIST, "$newtime\t$nvno\t$type\t$pgfmtno\t$point\t$ushost\t1\t$_POST[name]\t$_POST[tkb]\t$_POST[message]\n");
		}

		array_push($WDATA, array($dayfile, $DAYLIST));
	}

	// ★データ書き込み
	filewrite($WDATA);

	// メール送信
	if ($GLOBALS['CSTM']['clapmail'] == 1 && !empty($GLOBALS['CSTM']['clapmailad'])) {
		$to = $GLOBALS['CSTM']['clapmailad'];
		$subject = "【拍手通知】メッセージがありました";
		$body .= "以下の内容で拍手メッセージが届きました。\n\n";
		$body .= "---------------------------------------\n";
		$body .= "【日付】". date("Y/m/d H:i", $newtime). "\n";
		$body .= "【拍手箇所】". $point. "\n";
		if ($_POST['name'] !== '') $body .= "【名前】". $_POST['name']."\n";
		if ($_POST['tkb'] !== '') $body .= "【定形文】". $_POST['tkb']. "\n";
		$body .= "【メッセージ】". mb_convert_encoding(preg_replace("/<br \/>/", "\n", $_POST['message']), "JIS", "auto"). "\n";
		$body .= "---------------------------------------\n";
		$fromname = mb_encode_mimeheader($GLOBALS['CSTM']['maintitle']);
		$from = "From: ". $fromname. "<". $fromname. ">";

		mb_send_mail($to, $subject, $body, $from);
	}

	@header('Content-Type: text/html; charset: utf-8');

	echo '
	<a href="#" data-rel="back" data-role="button" data-theme="a" data-icon="delete" data-iconpos="notext" class="ui-btn-right">Close</a>
	<div class="ui-body">
		<h4>メッセージありがとうございます！</h4>
	</div>
	';
}

?>
