<?php
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
//////■ 以下スクリプト ■////
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
mb_language("japanese");
mb_internal_encoding("UTF-8");

// 外部ファイル読み込み
require_once('./config.php');
require_once($GLOBALS['path']['php']['system']);

$GLOBALS['script'] = $GLOBALS['path']['php']['mobile'];
//$GLOBALS['script'] = basename($_SERVER["SCRIPT_NAME"]);

configread(); // 設定データ取得
requestdecode(); // リクエストデコード
noveldata(1); // 小説データ取得

// テストクッキーセット
if (empty($_COOKIE['mtls'])) {
	setcookie('mtls', 1, $GLOBALS['nowtime'] + 60 * 60 * 24, '/', $_SERVER['SERVER_NAME']); //false
}

// 処理分岐
if ($_GET['mode'] === 'novel') {
	novel();
} else if ($_GET['mode'] === 'text') {
	text();
} else if ($_GET['mode'] === 'bookmark') {
	bookmark();
} else if ($_GET['mode'] === 'namechenge') {
	namechenge();
} else if ($_GET['mode'] === 'webclap') {
	webclap();
} else if ($_POST['mode'] === 'clapmessage') {
	clapmessage();
} else {
	top();
}

exit;
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ヘッダ・フッタ
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function htmlheader() {
	htmlstart_mbl();

	if (isset($GLOBALS['NOVEL'][$_REQUEST['nvno']]['title'])) {
		echo '
		[0]<a href="'. $GLOBALS['script']. '?" accesskey="0">TOP</a>
		[1]<a href="'. $GLOBALS['script']. '?mode=novel&amp;nvno='. $_REQUEST['nvno']. '" accesskey="1">'. $GLOBALS['NOVEL'][$_REQUEST['nvno']]['title']. '</a>
		<hr style="'. $GLOBALS['MOBILE']['hr']. '" />
		';
	}
}
function htmlfooter() {
	if (isset($GLOBALS['NOVEL'][$_REQUEST['nvno']]['title'])) {
		echo '
		<hr style="'. $GLOBALS['MOBILE']['hr']. '" />
		[0]<a href="'. $GLOBALS['script']. '?">TOP</a>
		[1]<a href="'. $GLOBALS['script']. '?mode=novel&amp;nvno='. $_REQUEST['nvno']. '">'. $GLOBALS['NOVEL'][$_REQUEST['nvno']]['title']. '</a>
		';
	}

	htmlend_mbl();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ トップページ
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function top() {
	htmlheader();

	echo '
	<div style="'. $GLOBALS['MOBILE']['title']. '">'. $GLOBALS['CSTM']['maintitle']. '</div>
	<hr style="'. $GLOBALS['MOBILE']['hr']. '" />
	<p>'. $GLOBALS['CSTM']['topmsg']. '</p>
	<hr style="'. $GLOBALS['MOBILE']['hr']. '" />
	';

	// 2013/12/10 TwitterAPI仕様変更により廃止
	// if ($GLOBALS['CSTM']['twitter'] == 1) {
	// 	$REQ = array();

	// 	echo '
	// 	<div style="line-height: 130%;">
	// 	<b>Twitter TL ';
	// 	if (!empty($GLOBALS['CSTM']['twt_id'])) { echo '@'.$GLOBALS['CSTM']['twt_id'].' '; $REQ[] = 'from:'.$GLOBALS['CSTM']['twt_id']; }
	// 	if (!empty($GLOBALS['CSTM']['twt_tag'])) { echo '#'.$GLOBALS['CSTM']['twt_tag'].' '; $REQ[] = '#'.$GLOBALS['CSTM']['twt_tag']; }
	// 	echo '
	// 	</b>
	// 	';

	// 	$page = (!empty($_GET['page'])) ? $_GET['page'] : 1;

	// 	$searchurl = 'http://search.twitter.com/search.json';
	// 	$params = http_build_query(array(
	// 				'q' => implode("+", $REQ),
	// 				'rpp'=> $GLOBALS['CSTM']['twt_tl'],
	// 				'page'=> $page,
	// 				'lang' => ja
	// 				));

	// 	$TWEETS = json_decode(file_get_contents("$searchurl?$params"), true);

	// 	foreach ($TWEETS['results'] as $RESULTS) {
	// 		$RESULTS['text'] = preg_replace("/(s?https?:\/\/[-_.!~*'()a-zA-Z0-9;\/?:@&=+$,%#]+)/", "<a href=\"$1\">$1</a>", $RESULTS['text']);
	// 		$RESULTS['text'] = preg_replace("/#(\S+)/", "<a href=\"http://twitter.com/search?q=%23$1\">#$1</a>", $RESULTS['text']);

	// 		echo '
	// 		<div><a href="https://twitter.com/'. $RESULTS['from_user']. '/status/'. $RESULTS['id_str']. '"><b>@'. $RESULTS['from_user']. '</b></a></div>
	// 		'. $RESULTS['text']. '
	// 		<div style="'. $GLOBALS['MOBILE']['date']. '"><small>'. date("Y/m/d (D) H:i", strtotime($RESULTS['created_at'])). '</small></div>
	// 		';
	// 	}

	// 	echo '
	// 	</div>
	// 	<hr style="'. $GLOBALS['MOBILE']['hr']. '" />
	// 	';
	// }

	// 小説一覧
	$page = 0;
	$maxpage = count($GLOBALS['NOVEL']);
	$nowpage = (!empty($_GET['page'])) ? $_GET['page'] : 1;
	foreach ($GLOBALS['NOVEL'] as $nvno => $NOVEL) {
		$page++;

		if ($nowpage > 1 && $page <= (($nowpage-1) * $GLOBALS['CSTM']['novelpgmx'])) continue;

		echo '
		<b>'. $NOVEL['title']. '</b>
		<div>'. $NOVEL['message']. '</div>
		<div style="'. $GLOBALS['MOBILE']['date']. '"><small>'. date("Y/m/d H:i", (($NOVEL['status'] === 'reserve') ? $NOVEL['rsvtime'] : $NOVEL['time_l'])). '更新</small></div>
		<div>[<a href="'. $GLOBALS['script']. '?mode=novel&amp;nvno='. $nvno. '">この小説を読む</a>]</div>
		'. ((!empty($_COOKIE['bookmark-novel'.$NOVEL['fmtno']])) ? '
			<div>[<a href="'. $GLOBALS['script']. '?mode=text&amp;nvno='. $nvno. '&amp;page='. $_COOKIE['bookmark-novel'.$NOVEL['fmtno']]. '">続きから読む</a>]</div>
		' : '');

		if ($page >= ($nowpage * $GLOBALS['CSTM']['novelpgmx'])) break;

		echo '
		<hr style="'. $GLOBALS['MOBILE']['hr']. '" />
		';
	}

	if ($maxpage > $GLOBALS['CSTM']['novelpgmx']) {

		echo '
		<hr style="'. $GLOBALS['MOBILE']['hr']. '" />
		';

		if ($nowpage != 1) {
			$back = $nowpage - 1;
			echo '[2]<a href="'.$GLOBALS['script'].'?page='.$back.'" accesskey="2">前へ</a>';
		} else {
			echo '[2]前へ';
		}

		if (($nowpage * $GLOBALS['CSTM']['novelpgmx']) < $maxpage) {
			$next = $nowpage + 1;
			echo '[3]<a href="'.$GLOBALS['script'].'?page='.$next.'" accesskey="3">次へ</a>';
		} else {
			echo '[3]次へ';
		}
	}

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 目次
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function mokuji($ncget = '') {
	echo '
	<a name="mokuji" id="mokuji"></a>
	<b>目次</b>
	';
	foreach ($GLOBALS['PAGE'] as $page => $PAGE) {

		if ($PAGE['type'] === 'text' && empty($PAGE['cpno'])) {
			echo '
			<div>
				<a href="'. $GLOBALS['script']. '?mode=text&amp;nvno='. $_GET['nvno']. '&amp;page='. $page. $ncget. '">
					<span'. (($_GET['page'] == $page) ? ' style="text-decoration: underline;"' : ''). '>'. ((!empty($PAGE['title'])) ? $PAGE['title'] : $page). '</span>
				</a>
			</div>
			';
		} else if ($PAGE['type'] === 'chapter') {
			echo '
			<div>
				<a href="'. $GLOBALS['script']. '?mode=text&amp;nvno='. $_GET['nvno']. '&amp;page='. $page. $ncget. '">
					<span'. (($_GET['page'] == $page) ? ' style="text-decoration: underline;"' : ''). '>'. ((!empty($PAGE['title'])) ? $PAGE['title'] : $page). '</span>
				</a>
			</div>
			';

			$endpage = end(array_keys($GLOBALS['TEXT'][$PAGE['fmtno']]));
			foreach ($GLOBALS['TEXT'][$PAGE['fmtno']] as $txpage => $TEXT) {

				//$title = sprintf("%02d", $page);
				//if (!empty($GLOBALS['PAGE'][$page]['title'])) $title .= ' '.$GLOBALS['PAGE'][$page]['title'];

				$lineimg = $GLOBALS['path']['dir']['img'].
				(($txpage == $endpage) ? $GLOBALS['path']['img']['line-r'] : $GLOBALS['path']['img']['line-rd']);

				echo '
				<div>
					'. (($txpage == $endpage) ? '└' : '├'). '
					<a href="'. $GLOBALS['script']. '?mode=text&amp;nvno='. $_GET['nvno']. '&amp;page='. $txpage. $ncget. '">
						<span'. (($_GET['page'] == $txpage) ? ' style="text-decoration: underline;"' : ''). '>'. ((!empty($TEXT['title'])) ? $TEXT['title'] : $txpage). '</span>
					</a>
				</div>
				';
			}
		}
	}
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 小説
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function novel() {
	htmlheader();

	echo '
	<div style="'. $GLOBALS['MOBILE']['title']. '">'. $GLOBALS['NOVEL'][$_GET['nvno']]['title']. '</div>
	<hr style="'. $GLOBALS['MOBILE']['hr']. '" />
	<div>'. $GLOBALS['NOVEL'][$_GET['nvno']]['outline']. '</div>
	<div style="'. $GLOBALS['MOBILE']['date']. '"><small>'. date("Y/m/d H:i", $GLOBALS['NOVEL'][$_GET['nvno']]['time_l']). '更新</small></div>
	<hr style="'. $GLOBALS['MOBILE']['hr']. '" />
	';

	mokuji();

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ページ表示
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function text() {
	// twitter
	$tweet = $GLOBALS['NOVEL'][$_GET['nvno']]['title'];

	// 名前変換
	$NAMECHENGE = array();
	$NMCNG_LIST = explode("<br />", $GLOBALS['NOVEL'][$_GET['nvno']]['namechenge']);
	if ($GLOBALS['CSTM']['namechenge'] == 1 && !empty($NMCNG_LIST[0])) {
		$i = 0;
		foreach ($NMCNG_LIST as $nmcng) {
			$i++;
			list($name, $guide) = explode("=", $nmcng, 2);
			$NAMECHENGE['search'][] = $name;
			if (!empty($_GET['nmcng'.$i])) {
				$NAMECHENGE['replace'][] = $_GET['nmcng'.$i];
				$ncget .= '&amp;nmcng'.$i.'='.urldecode($_GET['nmcng'.$i]);
				$flg = 1;
			} else {
				$NAMECHENGE['replace'][] = $name;
			}
		}
	}

	// 本文
	if ($GLOBALS['PAGE'][$_GET['page']]['type'] === 'text') {
		// ページ数
		if ($GLOBALS['CSTM']['cpview'] == 1) {
			$expage = $_GET['page']. ' / '. count($GLOBALS['PAGE']);
		} else {
			$expage = $GLOBALS['PAGELCN'][$_GET['page']]. ' / '. count($GLOBALS['TYPE']['text']);
		}

		list($maintext) = fileread('novel/'.$GLOBALS['NOVEL'][$_GET['nvno']]['fmtno'].'/txt'.$GLOBALS['PAGE'][$_GET['page']]['fmtno'].'.dat');

		// 名前変換実行
		if (!empty($flg)) {
			$maintext = str_replace($NAMECHENGE['search'], $NAMECHENGE['replace'], $maintext);
		}

		$cppgno = $GLOBALS['TYPE']['chapter'][$GLOBALS['PAGE'][$_GET['page']]['cpno']]; // 章番号取得

		$subtitle = ((isset($cppgno)) ? $GLOBALS['PAGE'][$cppgno]['title'].' － ' : '').
					$GLOBALS['PAGE'][$_GET['page']]['title']; // サブタイトル

		$tweet .= ' － '.$subtitle;

		$mainarea = '
		<div style="'. $GLOBALS['MOBILE']['texttheme']. '">
		<p><b>　'. $subtitle. '</b></p>
		<p>'. $maintext. '</p>
		</div>
		<div style="'. $GLOBALS['MOBILE']['date']. '"><small>'. date("Y/m/d H:i", $GLOBALS['PAGE'][$_GET['page']]['time_l']). '更新</small></div>
		';

	// 章
	} else if ($GLOBALS['PAGE'][$_GET['page']]['type'] === 'chapter') {
		// ページ数
		if ($GLOBALS['CSTM']['cpview'] == 1) {
			$expage = $_GET['page']. ' / '. count($GLOBALS['PAGE']);
		}

		list($maintext) = fileread('novel/'.$GLOBALS['NOVEL'][$_GET['nvno']]['fmtno'].'/cp'.$GLOBALS['PAGE'][$_GET['page']]['fmtno'].'.dat');

		// 名前変換実行
		if (!empty($flg)) {
			$maintext = str_replace($NAMECHENGE['search'], $NAMECHENGE['replace'], $maintext);
		}

		$tweet .= ' － '.$GLOBALS['PAGE'][$_GET['page']]['title'];

		$mainarea = '
		<div align="center" style="text-align: center;"><big><b>'. $GLOBALS['PAGE'][$_GET['page']]['title']. '</b></big></div>
		<p>'. $maintext. '</p>
		<div style="'. $GLOBALS['MOBILE']['date']. '">'. date("Y/m/d H:i", $GLOBALS['PAGE'][$_GET['page']]['time_l']). '</div>
		';
	}

	// ヘッダー／フッター
	$navi = '';
		if ($_GET['page'] > 1) {
			$back = ($GLOBALS['CSTM']['cpview'] != 1 && $GLOBALS['PAGE'][($_GET['page'] - 1)]['type'] === 'chapter') ? $_GET['page'] - 2 : $_GET['page'] - 1;
			$navi .= '[3]<a href="'. $GLOBALS['script']. '?mode=text&amp;nvno='. $_GET['nvno']. '&amp;page='. $back. $ncget. '" accesskey="3">前へ</a>';
		} else {
			$navi .= '[3]前へ';
		}
		if ($_GET['page'] < count($GLOBALS['PAGE'])) {
			$next = ($GLOBALS['CSTM']['cpview'] != 1 && $GLOBALS['PAGE'][($_GET['page'] + 1)]['type'] === 'chapter') ? $_GET['page'] + 2 : $_GET['page'] + 1;
			$navi .= '[4]<a href="'. $GLOBALS['script']. '?mode=text&amp;nvno='. $_GET['nvno']. '&amp;page='. $next. $ncget. '" accesskey="4">次へ</a>';
		} else {
			$navi .= '[4]次へ';
		}
		$navi .= ' '. $expage. '
	<hr style="'. $GLOBALS['MOBILE']['hr']. '" />
	';

	// 出力開始
	htmlheader();

	echo '
	<div style="'. $GLOBALS['MOBILE']['title']. '">'. $GLOBALS['NOVEL'][$_GET['nvno']]['title']. '</div>
	<hr style="'. $GLOBALS['MOBILE']['hr']. '" />
	[2]<a href="#mokuji"  accesskey="2">目次</a>
	'. $navi. $mainarea. '
	<hr style="'. $GLOBALS['MOBILE']['hr']. '" />
	'. $navi;

	if (!empty($_COOKIE['mtls'])) {
		echo '
		<div>[5]<a href="'. $GLOBALS['script']. '?mode=bookmark&amp;nvno='. $_GET['nvno']. '&amp;page='. $_GET['page']. '" accesskey="5">栞を挟む</a></div>
		';
	}

	if ($GLOBALS['CSTM']['webclap'] == 1) {
		if ($GLOBALS['CSTM']['clapcount'] == 1) {
			$count = 0;
			foreach (fileread('clap/clap.dat') as $list) {
				list($nvno, $type, $pgfmtno, $clap) = explode("\t", rtrim($list));

				if ($nvno == $GLOBALS['NOVEL'][$_GET['nvno']]['fmtno']
				&& $type === $GLOBALS['PAGE'][$_GET['page']]['type']
				&& $pgfmtno == $GLOBALS['PAGE'][$_GET['page']]['fmtno']) {
					$count = $clap;
					break;
				}
			}
			$clapcount = '(<span style="color: #CC3333;">'. $count. '</span>)';
		}
		echo '
		<div>[6]<a href="'. $GLOBALS['script']. '?mode=webclap&amp;nvno='. $_GET['nvno']. '&amp;page='. $_GET['page']. '" accesskey="6">WEB拍手</a>'. $clapcount. '</div>
		';
	}

	if ($GLOBALS['CSTM']['namechenge'] == 1 && !empty($NMCNG_LIST[0])) {
		echo '
		<div>[7]<a href="'. $GLOBALS['script']. '?mode=namechenge&amp;nvno='. $_GET['nvno']. '&amp;page='. $_GET['page']. '" accesskey="7">名前変換</a></div>
		';
	}

	if ($GLOBALS['CSTM']['twitter'] == 1) {
		echo '
		<div>[8]<a href="http://twitter.com/?status='. urlencode($tweet.' '.__FILE__.'?mode=text&page='.$_GET['page']). '" accesskey="8">ツイート</a></div>
		';
	}

	echo '
	<hr style="'. $GLOBALS['MOBILE']['hr']. '" />
	';

	mokuji($ncget);

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ブックマーク
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function bookmark() {
	setcookie('bookmark-novel'.$GLOBALS['NOVEL'][$_GET['nvno']]['fmtno'], $_GET['page'], $GLOBALS['nowtime'] + 60 * 60 * 24 * 30, '/', $_SERVER['SERVER_NAME']);

	htmlheader();

	echo '
	<p>現在のページに栞を挟みました。</p>
	<p><a href="'. $GLOBALS['script']. '?mode=text&amp;nvno='. $_GET['nvno']. '&amp;page='. $_GET['page']. '">前のページに戻る</a></p>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 名前変換
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function namechenge() {
	// 名前変換
	$NAMECHENGE = array();
	$NMCNG_LIST = explode("<br />", $GLOBALS['NOVEL'][$_GET['nvno']]['namechenge']);

	htmlheader();

	echo '
	<form action="'. $GLOBALS['script']. '" method="get">
	<input type="hidden" name="mode" value="text" />
	<input type="hidden" name="nvno" value="'. $_GET['nvno']. '" />
	<input type="hidden" name="page" value="'. $_GET['page']. '" />
	<b>名前変換</b>
	';
	$i = 0;
	foreach ($NMCNG_LIST as $nmcng) {
		$i++;
		list($name, $guide) = explode("=", $nmcng, 2);

		echo '
		<div><input type="text" name="nmcng'. $i. '" value="'. ((!empty($_GET['nmcng'.$i])) ? $_GET['nmcng'.$i] : $name). '" /> = '. $guide. '</div>
		';
	}
	echo '
	<input type="submit" value="名前変換" />
	</form>
	<p><a href="'. $GLOBALS['script']. '?mode=text&amp;nvno='. $_GET['nvno']. '&amp;page='. $_GET['page']. '">前のページに戻る</a></p>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ WEB拍手
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function webclap() {
	$point = $GLOBALS['NOVEL'][$_GET['nvno']]['title'];

	if (!empty($_GET['page'])) {
		$point .= ' > '. ((!empty($GLOBALS['PAGE'][$_GET['page']]['title'])) ? $GLOBALS['PAGE'][$_GET['page']]['title'] : sprintf("%02d", $_GET['page']));
		$type = $GLOBALS['PAGE'][$_GET['page']]['type'];
		$pgfmtno = $GLOBALS['PAGE'][$_GET['page']]['fmtno'];
	} else {
		$type = 'novel';
	}

	$nvno = $GLOBALS['NOVEL'][$_GET['nvno']]['fmtno'];

	$newtime = $GLOBALS['nowtime'];
	$ushost = get_host();

	$WDATA = array();

	// ▼当日拍手保存ファイル書き込み
	$clapdir = 'clap/'.date("Y");

	if (!file_exists($GLOBALS['path']['dir']['data'].$clapdir)) {
		umask(0);
		mkdir($GLOBALS['path']['dir']['data'].$clapdir);
	}

	$dayfile = "$clapdir/".date("m-d").'.dat';

	if (!file_exists($GLOBALS['path']['dir']['data'].$dayfile)) {
		// 新規ファイルから書き込み
		//$chainset = (isset($ckchain)) ? $ckchain : 1;
		$clapbase = "$newtime\t$nvno\t$type\t$pgfmtno\t$point\t$ushost\t1\t\t\t\n";
		array_push($WDATA, array($dayfile, $clapbase));
	} else {
		// 既存ファイルから書き込み
		$DAYLIST = fileread($dayfile);

		foreach ($DAYLIST as &$line) {
			list($time, $exnvno, $extype, $expgfmtno, $expoint, $host, $clap, $name, $tkb, $message) = explode("\t", $line);

			if ($exnvno == $nvno && $extype === $type && $expgfmtno == $pgfmtno && $host === $ushost) {

				//$chainset = (isset($ckchain)) ? $ckchain : $chain + 1;
				$clap += 1;

				// ホストチェックによる連続拍手制限
				if ($GLOBALS['CSTM']['clapmax'] > 0 && $clap > $GLOBALS['CSTM']['clapmax']) {
					error_mobile('拍手限度を超えています。');
				}

				$line = "$time\t$exnvno\t$extype\t$expgfmtno\t$point\t$ushost\t$clap\t$name\t$tkb\t$message";
				$flga = 1;
				break;
			}
		}
		if (empty($flga)) {
			//$chainset = (isset($ckchain)) ? $ckchain : 1;
			array_push($DAYLIST, "$newtime\t$nvno\t$type\t$pgfmtno\t$point\t$ushost\t1\t\t\t\n");
		}

		array_push($WDATA, array($dayfile, $DAYLIST));
	}

	// ▼個別拍手保存ファイル書き込み
	$CLAPLIST = fileread('clap/clap.dat');
	foreach ($CLAPLIST as &$line) {
		list($exnvno, $extype, $expgfmtno, $clap) = explode("\t", rtrim($line));

		if ($exnvno == $nvno && $extype === $type && $expgfmtno == $pgfmtno) {
			$clap++;
			$line = "$nvno\t$extype\t$expgfmtno\t$clap\n";
			$flgb = 1;
			$clapcount = $clap;
			break;
		}
	}
	if (empty($flgb)) {
		array_push($CLAPLIST, "$nvno\t$type\t$pgfmtno\t1\n");
		$clapcount = 1;
	}
	array_push($WDATA, array('clap/clap.dat', $CLAPLIST));

	// ★データ書き込み
	filewrite($WDATA);

	htmlheader();

	echo '
	<h4>拍手ありがとうございます！</h4>
	<p>よろしければメッセージをどうぞ！</p>
	<hr style="'. $GLOBALS['MOBILE']['hr']. '" />
	<form action="'. $GLOBALS['script']. '" method="post">
	<input type="hidden" name="mode" value="clapmessage" />
	<input type="hidden" name="nvno" value="'. $_GET['nvno']. '" />
	<input type="hidden" name="page" value="'. $_GET['page']. '" />
	<div>名前:</div>
	<input type="text" name="name" value="" />
	';

	if (!empty($GLOBALS['CSTM']['claptkb'])) {
		echo '
		<div>定形文:</div>
		<select name="tkb">
		<option value="">▼定形文</option>
		';
		foreach (explode("<br />", $GLOBALS['CSTM']['claptkb']) as $tkb) {
			echo '<option value="'. $tkb. '">'. $tkb. '</option>';
		}
		echo '
		</select>
		';
	}

	echo '
	<div>メッセージ:</div>
	<textarea name="message"></textarea>
	<div><input type="submit" value="送信" /></div>
	</form>
	<p><a href="'. $GLOBALS['script']. '?mode=text&amp;nvno='. $_GET['nvno']. '&amp;page='. $_GET['page']. '">前のページに戻る</a></p>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 拍手メッセージ
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function clapmessage() {
	$point = $GLOBALS['NOVEL'][$_POST['nvno']]['title'];

	if (!empty($_POST['page'])) {
		$point .= ' > '. ((!empty($GLOBALS['PAGE'][$_POST['page']]['title'])) ? $GLOBALS['PAGE'][$_POST['page']]['title'] : sprintf("%02d", $_POST['page']));
		$type = $GLOBALS['PAGE'][$_POST['page']]['type'];
		$pgfmtno = $GLOBALS['PAGE'][$_POST['page']]['fmtno'];
	} else {
		$type = 'novel';
	}

	$nvno = $GLOBALS['NOVEL'][$_POST['nvno']]['fmtno'];

	$newtime = $GLOBALS['nowtime'];
	$ushost = get_host();

	$WDATA = array();

	// ▼当日拍手保存ファイル書き込み
	$clapdir = 'clap/'.date("Y");

	if (!file_exists($GLOBALS['path']['dir']['data'].$clapdir)) {
		umask(0);
		mkdir($GLOBALS['path']['dir']['data'].$clapdir);
	}

	$dayfile = "$clapdir/".date("m-d").'.dat';

	if (!file_exists($GLOBALS['path']['dir']['data'].$dayfile)) {
		// 新規ファイルから書き込み
		$clapbase = "$newtime\t$nvno\t$type\t$pgfmtno\t$point\t$ushost\t1\t$_POST[name]\t$_POST[tkb]\t$_POST[message]\n";
		array_push($WDATA, array($dayfile, $clapbase));
	} else {
		// 既存ファイルから書き込み
		$DAYLIST = fileread($dayfile);

		foreach ($DAYLIST as &$line) {
			list($time, $exnvno, $extype, $expgfmtno, $expoint, $host, $clap, $name, $tkb, $message) = explode("\t", rtrim($line));

			if ($exnvno == $nvno && $extype === $type && $expgfmtno == $pgfmtno && $host === $ushost) {
				if (!empty($message)) $message .= "<br />";
				$message .= "$_POST[message]";
				$line = "$newtime\t$exnvno\t$extype\t$expgfmtno\t$point\t$ushost\t$clap\t$_POST[name]\t$_POST[tkb]\t$message\n";
				$flga = 1;
				break;
			}
		}
		if (empty($flga)) {
			array_push($DAYLIST, "$newtime\t$nvno\t$type\t$pgfmtno\t$point\t$ushost\t1\t$_POST[name]\t$_POST[tkb]\t$_POST[message]\n");
		}

		array_push($WDATA, array($dayfile, $DAYLIST));
	}

	// ★データ書き込み
	filewrite($WDATA);

	// メール送信
	if ($GLOBALS['CSTM']['clapmail'] == 1 && !empty($GLOBALS['CSTM']['clapmailad'])) {
		$to = $GLOBALS['CSTM']['clapmailad'];
		$subject = "【拍手通知】メッセージがありました";
		$body .= "以下の内容で拍手メッセージが届きました。\n\n";
		$body .= "---------------------------------------\n";
		$body .= "【日付】". date("Y/m/d H:i", $newtime). "\n";
		$body .= "【拍手箇所】". $point. "\n";
		if ($_POST['name'] !== '') $body .= "【名前】". $_POST['name']."\n";
		if ($_POST['tkb'] !== '') $body .= "【定形文】". $_POST['tkb']. "\n";
		$body .= "【メッセージ】". mb_convert_encoding(preg_replace("/<br \/>/", "\n", $_POST['message']), "JIS", "auto"). "\n";
		$body .= "---------------------------------------\n";
		$fromname = mb_encode_mimeheader($GLOBALS['CSTM']['maintitle']);
		$from = "From: ". $fromname. "<". $fromname. ">";

		mb_send_mail($to, $subject, $body, $from);
	}

	htmlheader();

	echo '
	<p><h4>メッセージありがとうございます！</h4></p>
	<p><a href="'. $GLOBALS['script']. '?mode=text&amp;nvno='. $_POST['nvno']. '&amp;page='. $_POST['page']. '">前のページに戻る</a></p>
	';

	htmlfooter();
}

?>
